


package com.vektorsoft.demux.samples.extension.jfx;

import com.vektorsoft.demux.core.mva.DMXAdapter;
import com.vektorsoft.demux.core.resources.ResourceHandlerType;
import com.vektorsoft.demux.core.resources.impl.DefaultResourceHandler;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTrackerCustomizer;

/**
 *
 * @author Vladimir Djurovic
 */
public class SampleCustomizer implements ServiceTrackerCustomizer<DMXAdapter, DMXAdapter> {
    
    private BundleContext context;
    
    public SampleCustomizer(BundleContext ctx){
        this.context = ctx;
    }

    @Override
    public DMXAdapter addingService(ServiceReference<DMXAdapter> sr) {
        DMXAdapter svc = (DMXAdapter)context.getService(sr);
        
        DefaultResourceHandler handler = svc.getResourceManager().getResourceHandler(ResourceHandlerType.RESOURCE_BUNDLE);
        handler.loadResourceBundle("strings", getClass().getClassLoader());
        System.out.println("Loaded resource bundle.");
        // register views and controllers here
        svc.registerView(ExtendableView.class);
        System.out.println("Registered extendable view");
//         svc.registerController(new HelloController());
//         HelloView view = new HelloView();
//         view.setAdapter(svc);
//         svc.registerView(view);
       return svc;
    }

    @Override
    public void modifiedService(ServiceReference<DMXAdapter> sr, DMXAdapter t) {
        
    }

    @Override
    public void removedService(ServiceReference<DMXAdapter> sr, DMXAdapter t) {

    }

}
