


package com.vektorsoft.demux.samples.props;

import com.vektorsoft.demux.core.mva.DMXAdapter;
import javafx.event.ActionEvent;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTrackerCustomizer;


public class SampleCustomizer implements ServiceTrackerCustomizer<DMXAdapter, DMXAdapter> {
    
    private BundleContext context;
    
    public SampleCustomizer(BundleContext ctx){
        this.context = ctx;
    }

    @Override
    public DMXAdapter addingService(ServiceReference<DMXAdapter> sr) {
        DMXAdapter svc = (DMXAdapter)context.getService(sr);
        
        // register views and controllers here
        svc.registerView(PropertyView.class);
        svc.registerController(new ClickController());
        svc.registerEventHandler(new CheckListener(svc));
        svc.registerEventHandler(new ButtonClickListener(svc, ActionEvent.ACTION));
       return svc;
    }

    @Override
    public void modifiedService(ServiceReference<DMXAdapter> sr, DMXAdapter t) {
        
    }

    @Override
    public void removedService(ServiceReference<DMXAdapter> sr, DMXAdapter t) {

    }

}
